package zabi.uniud.cggwrapper.launch;

import java.awt.Frame;
import java.io.File;
import java.util.LinkedList;
import java.util.List;

import javax.swing.JOptionPane;

import com.chronogeograph.ChronoGeoGraphFrame;

import zabi.uniud.cggwrapper.Config;

public class AppLaunch {

	public static void main(String[] args) {

		try {
			if ("true".equals(System.getProperty("skipSplash"))) {
				ChronoGeoGraphFrame frame = new ChronoGeoGraphFrame();
				frame.setExtendedState(Frame.MAXIMIZED_BOTH);
				frame.setVisible(true);
			} else {
				ChronoGeoGraphFrame.main(args);
			}
		} catch (Throwable t) {
			t.printStackTrace();
			JOptionPane.showMessageDialog(null, t.getMessage(), "Error launching", JOptionPane.ERROR_MESSAGE);
			System.exit(-1);
		}
	}

	public static void runNewInstance(Config cf, String[] args) {
		String javaHome = System.getProperty("java.home");
		String javaBin = javaHome + File.separator + "bin" + File.separator + "java";
		String classpath = System.getProperty("java.class.path");
		String className = AppLaunch.class.getName();

		List<String> command = new LinkedList<String>();
		command.add(javaBin);
		if (cf.useAA) {
			command.add("-Dawt.useSystemAAFontSettings=on");
		}
		if (cf.useGL) {
			command.add("-Dsun.java2d.opengl=True");
		}
		if (cf.splash) {
			command.add("-DskipSplash=true");
		}
		command.add("-cp");
		command.add(classpath);
		command.add(className);

		for (String s:args) {
			command.add(s);
		}

		ProcessBuilder builder = new ProcessBuilder(command);

		try {
			Process process = builder.inheritIO().start();
			process.waitFor();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(251);
		}
	}

}
